package com.example.tdl.mapper;

import com.example.tdl.domain.vo.ProbesVo;
import com.example.tdl.domain.vo.ResultProbesVo;
import com.example.tdl.domain.vo.UpdateProbesVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface ProbesMapper {
    List<ResultProbesVo> getProbesByGateway(@Param("SN") String SN, @Param("type") String type);

    ResultProbesVo getByPortAndGateway(@Param("SN") String SN, @Param("type") String type, @Param("port") int port);

    ResultProbesVo getByAliasAndGateway(@Param("SN") String SN, @Param("type") String type, @Param("alias") String alias);

    ResultProbesVo getByDescriptionAndGateway(@Param("SN") String SN, @Param("type") String type, @Param("description") String description);

    List<Integer> getAllPort(@Param("SN") String SN, @Param("type") String type);

    List<String> getAllAlias(@Param("SN") String SN, @Param("type") String type);

    List<String> getUnitByAlias(@Param("SN") String SN, @Param("type") String type);

    List<String> getNameByAliasList(@Param("SN") String SN, @Param("type") String type, @Param("aliasList") List<String> aliasList);

    List<ProbesVo> getByAliasList(@Param("SN") String SN, @Param("type") String type, @Param("aliasList") List<String> aliasList);

    Integer getCountByGateway(@Param("SN") String SN, @Param("type") String type);

    int addProbes(Map<String, Object> map);

    int updateProbes(UpdateProbesVo updateProbesVo);

    int delAProbes(Map<String, Object> map);

    int delAllProbes(Map<String, Object> map);

}
