package com.example.tdl.service;

import com.example.tdl.domain.vo.AddAlarmLogVo;
import com.example.tdl.domain.vo.AlarmLogVo;
import com.example.tdl.domain.vo.HistogramData;
import com.example.tdl.domain.vo.ResultAlarmLog;
import com.example.tdl.mapper.AlarmLogMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AlarmLogService {

    @Autowired
    private AlarmLogMapper alarmLogMapper;

    public List<ResultAlarmLog> getAll(){
        return alarmLogMapper.getAll();
    }

    public List<AlarmLogVo> getAlarmLog(String time){
        return  alarmLogMapper.getAlarmLog(time);
    }

    public int addAlarmLog(AddAlarmLogVo addAlarmLogVo){
        return alarmLogMapper.addAlarmLog(addAlarmLogVo);
    }

    public List<ResultAlarmLog> getByTransportationNo(String  transportationNo){
        return  alarmLogMapper.getByTransportationNo(transportationNo);
    }

    public Integer getCount(String time){
        return alarmLogMapper.getCount(time);
    }

    public Integer getBumpCount(String time){
        return alarmLogMapper.getBumpCount(time);
    }

    public List<HistogramData> getByCount(String time){
         return alarmLogMapper.getByCount(time);
    }


    public Integer getByTime(String transportationNo,Long startTime,Long endTime){
            return alarmLogMapper.getByTime(transportationNo,startTime,endTime);
    }


}
