package com.example.tdl.service;


import com.example.tdl.domain.vo.AddAlarmVo;
import com.example.tdl.domain.vo.DelAlarmVo;
import com.example.tdl.domain.vo.ResultAlarmVo;
import com.example.tdl.domain.vo.UpdateAlarmVo;
import com.example.tdl.mapper.AlarmMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


@Service
public class AlarmService {
    @Autowired
    private AlarmMapper alarmMapper;

    public List<ResultAlarmVo> getAll(){
        return alarmMapper.getAll();
    }

    public List<ResultAlarmVo> getAllByAlarmType(String alarmType){
        return alarmMapper.getAllByAlarmType(alarmType);
    }

    public int addAlarm(AddAlarmVo addAlarmVo){
        return alarmMapper.addAlarm(addAlarmVo);
    }

    public int updateAlarm(UpdateAlarmVo updateAlarmVo){
        return alarmMapper.updateAlarm(updateAlarmVo);
    }

    public int delAlarm(DelAlarmVo delAlarmVo){
        return alarmMapper.delAlarm(delAlarmVo);
    }

    public ResultAlarmVo getByTypeAndScene(String alarmType,String alarmScene){
        return alarmMapper.getByTypeAndScene(alarmType,alarmScene);
    }

    public List<String> getForWarehouse(){
        return alarmMapper.getForWarehouse();
    }

}
