package com.example.tdl.service;


import com.example.tdl.domain.vo.*;
import com.example.tdl.mapper.CircuitMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class CircuitService {
    @Autowired
    private CircuitMapper circuitMapper;

    public List<ResultCircuitVo> getAll(){
        return circuitMapper.getAll();
    }

    public List<ResultCircuitVo> getByTerm(CircuitTermVo circuitTermVo){
        return circuitMapper.getByTerm(circuitTermVo);
    }

    public int addCircuit(Map<Object,Object> map){
        return circuitMapper.addCircuit(map);
    }

    public int updateCircuit(Map<Object,Object> map){
        return circuitMapper.updateCircuit(map);
    }


    public int updateEndTime(UpdateCircuitVo updateCircuitVo){
        return circuitMapper.updateEndTime(updateCircuitVo);
    }

    public int delCircuit(String transportationNo){
        return circuitMapper.delCircuit(transportationNo);
    }

    public ResultCircuitVo getByTransportationNo(String transportationNo){
        return circuitMapper.getByTransportationNo(transportationNo);
    }

    public Integer getOnRoute(String time){
        return circuitMapper.getOnRoute(time);
    }

    public Integer getDelayCount(Long compTime,String time){
        return circuitMapper.getDelayCount(compTime,time);
    }

    public Integer getComplted(String time){
        return circuitMapper.getComplted(time);
    }


    public Integer getCount(String time){
        return circuitMapper.getCount(time);
    }

    public List<ResultCircuitVo> getByTime(String time){
        return circuitMapper.getByTime(time);
    }

    public List<ResultCircuitVo> getByContainerNo(String cargoNo){
        return circuitMapper.getByContainerNo(cargoNo);
    }

    public int updateEvaluate(UpdateEvaluateVo updateEvaluateVo){
        return circuitMapper.updateEvaluate(updateEvaluateVo);
    }

    public List<ResultCircuitVo> getByCircuitState(Integer circuitState){
        return circuitMapper.getByCircuitState(circuitState);
    }

    public Integer getNo(String transportationNo){
            return circuitMapper.getNo(transportationNo);
    }

    public ResultGatewayVo getByNo(String transportationNo){
        return circuitMapper.getByNo(transportationNo);
    }

    //    public List<CircuitVo> getDistinct(){
//        return circuitMapper.getDistinct();
//    }

}
