package com.example.tdl.service;

import com.example.tdl.domain.vo.ProbesVo;
import com.example.tdl.domain.vo.ResultProbesVo;
import com.example.tdl.domain.vo.UpdateProbesVo;
import com.example.tdl.mapper.ProbesMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class ProbesService {

    @Autowired
    private ProbesMapper probesMapper;

    public List<ResultProbesVo> getProbesByGateway(String SN, String type){
        return probesMapper.getProbesByGateway(SN,type);
    }

    public ResultProbesVo getByPortAndGateway(String SN,String type,int port){
        return probesMapper.getByPortAndGateway(SN,type,port);
    }

    public ResultProbesVo getByAliasAndGateway(String SN,String type,String alias){
        return probesMapper.getByAliasAndGateway(SN,type,alias);
    }

    public ResultProbesVo getByDescriptionAndGateway(String SN,String type,String description){
        return probesMapper.getByDescriptionAndGateway(SN,type,description);
    }

    public List<Integer> getAllPort(String SN, String type){
        return probesMapper.getAllPort(SN, type);
    }

    public List<String> getAllAlias(String SN, String type){
        return probesMapper.getAllAlias(SN, type);
    }

    public List<String> getUnitByAlias(String SN, String type){
        return probesMapper.getUnitByAlias(SN, type);
    }

    public List<String> getNameByAliasList(String SN, String type,List<String> aliasList){
        return probesMapper.getNameByAliasList(SN, type,aliasList);
    }

    public List<ProbesVo> getByAliasList(String SN, String type, List<String> aliasList){
        return probesMapper.getByAliasList(SN, type,aliasList);
    }

    public Integer getCountByGateway(String SN, String type){
        return probesMapper.getCountByGateway(SN,type);
    }

    public int addProbes(Map<String,Object> map){
        return probesMapper.addProbes(map);
    }

    public int updateProbes(UpdateProbesVo updateProbesVo){
        return probesMapper.updateProbes(updateProbesVo);
    }

    public int delAProbes(Map<String,Object> map){
        return probesMapper.delAProbes(map);
    }

    public int delAllProbes(Map<String,Object> map){
        return probesMapper.delAllProbes(map);
    }

}
