package com.example.tdl.service;

import com.example.tdl.domain.vo.AddTDLDeviceVo;
import com.example.tdl.domain.vo.ResultTDLDeviceVo;
import com.example.tdl.domain.vo.TDLDeviceTermVo;
import com.example.tdl.domain.vo.UpdateTDLDeviceVo;
import com.example.tdl.mapper.TDLDeviceMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class TDLDeviceService {
    @Autowired
    private TDLDeviceMapper tdlDeviceMapper;

    public List<ResultTDLDeviceVo> getAll(){
        return tdlDeviceMapper.getAll();
    }

    public List<ResultTDLDeviceVo> getByTerm(TDLDeviceTermVo tdlDeviceTermVo){
        return tdlDeviceMapper.getByTerm(tdlDeviceTermVo);
    }

    public int addTDLDevice(AddTDLDeviceVo addTDLDeviceVo){
        return tdlDeviceMapper.addTDLDevice(addTDLDeviceVo);
    }

    public int updateTDLDevice(UpdateTDLDeviceVo updateTDLDeviceVo){
        return tdlDeviceMapper.updateTDLDevice(updateTDLDeviceVo);
    }

    public int delTDLDevice(String TDLSN){
        return tdlDeviceMapper.delTDLDevice(TDLSN);
    }

    public ResultTDLDeviceVo getByTDLSN(String TDLSN){
        return tdlDeviceMapper.getByTDLSN(TDLSN);
    }

    public List<String> getByGatewaySN(String SN,String type){
        return  tdlDeviceMapper.getByGatewaySN(SN,type);
    }
}
