package com.example.tdl.service;

import com.example.tdl.domain.vo.*;
import com.example.tdl.mapper.UserMapper;
import com.example.tdl.service.redis.TokenRedisService;
import com.google.gson.Gson;
import org.apache.commons.codec.digest.DigestUtils;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class UserService {

    Gson gson = new Gson();

    @Autowired
    private UserMapper userMapper;

    @Autowired
    private TokenRedisService redisService;

    public int login(LoginUserVo loginUserVo){
        return userMapper.login(loginUserVo);
    }

    public UserVo getByUserName(String userName){
        return userMapper.getByUserName(userName);
    }

    public List<ResultUserVo> getAll(){
        return userMapper.getAll();
    }

    public List<ResultUserVo> getByTerm(UserTermVo userTermVo){
        return userMapper.getByTerm(userTermVo);
    }

    public ResultUserVo getByPhone(String phone){
        return userMapper.getByPhone(phone);
    }

    public ResultUserVo getByEmail(String email){
        return userMapper.getByEmail(email);
    }

    public ResultUserVo getByUserNumber(String userNumber){
        return userMapper.getByUserNumber(userNumber);
    }

    public int addUser(AddUserVo addUserVo){
        return userMapper.addUser(addUserVo);
    }

    public int updateUser(UpdateUserVo userVo){
        return userMapper.updateUser(userVo);
    }

    public int delUser(String userNumber){
        return userMapper.delUser(userNumber);
    }

    public int updatePassword(UpdatePasswordVo updatePasswordVo){
        return userMapper.updatePassword(updatePasswordVo);
    }


    //登录
    public String getUser(LoginUserVo loginUserVo) {
        //获取用户信息
        UserVo userVo = userMapper.getByUserName(loginUserVo.getUserName());
        if(userVo == null){
            return null;
        }
        //匹配密码
        if(!userVo.getPassword().equals(DigestUtils.sha256Hex(loginUserVo.getPassword()))){
            return null;
        }
        String token = DigestUtils.md5Hex(System.currentTimeMillis() + userVo.getUserName());
        UserRedisVo redisVo = new UserRedisVo(userVo.getUserName(),userVo.getUserNumber(),userVo.getNickName(),userVo.getEmail(),userVo.getPhone(),userVo.getRoleName());
        //将用户数据保存到redis中
        redisService.set("TOKEN_" + token, gson.toJson(redisVo), 60 * 30);
        return  token;
    }
}
