package com.example.tdl.service;


import com.example.tdl.domain.vo.DelAlarmVo;
import com.example.tdl.domain.vo.ResultWarehouseVo;
import com.example.tdl.domain.vo.UpdateWarehouseVo;
import com.example.tdl.domain.vo.WarehouseTermVo;
import com.example.tdl.entity.Warehouse;
import com.example.tdl.mapper.WarehouseMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class WarehouseService {
    @Autowired
    private WarehouseMapper warehouseMapper;

    public List<ResultWarehouseVo> getAll(){
        return warehouseMapper.getAll();
    }

    public List<ResultWarehouseVo> getAllByTerm(WarehouseTermVo warehouseTermVo){
        return warehouseMapper.getAllByTerm(warehouseTermVo);
    }

    public int addWarehouse(Warehouse warehouse){
        return warehouseMapper.addWarehouse(warehouse);
    }

    public int updateWarehouse(UpdateWarehouseVo updateWarehouseVo){
        return warehouseMapper.updateWarehouse(updateWarehouseVo);
    }

    public int delWarehouse(String warehouseNo){
        return warehouseMapper.delWarehouse(warehouseNo);
    }

    public ResultWarehouseVo getByWarehouseName(String warehouseName){
        return warehouseMapper.getByWarehouseName(warehouseName);
    }

    public List<ResultWarehouseVo> getByAlarm(DelAlarmVo delAlarmVo){
        return warehouseMapper.getByAlarm(delAlarmVo);
    }

}
