package com.example.tdl.web;

import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.domain.vo.AddAlarmLogVo;
import com.example.tdl.service.AlarmLogService;
import com.google.gson.Gson;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


@RestController
@RequestMapping("/alarmLog")
public class AlarmLogController {
    private Logger logger= LoggerFactory.getLogger(AlarmLogController.class);

    Gson gson= new Gson();

    CommFeedback fb=new CommFeedback();

    @Autowired
    private AlarmLogService alarmLogServcie;

    //新增报警消息
    @PostMapping("/addAlarmLog")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
    })
    public Object addAlarmLog(@RequestBody AddAlarmLogVo addAlarmLogVo){
        if(StringUtils.isEmpty(addAlarmLogVo.getTransportationNo())){
            fb.setCode(0);
            fb.setMessage("运输编号不能为空");
            return gson.toJson(fb);
        }
        if(StringUtils.isEmpty(addAlarmLogVo.getTDLSN())){
            fb.setCode(0);
            fb.setMessage("路由名称不能为空");
            return gson.toJson(fb);
        }
        if(StringUtils.isEmpty(addAlarmLogVo.getDescription())){
            fb.setCode(0);
            fb.setMessage("报警描述不能为空");
            return gson.toJson(fb);
        }
        if(addAlarmLogVo.getData() == null){
            fb.setCode(0);
            fb.setMessage("报警数据不能为空");
            return gson.toJson(fb);
        }
        if(addAlarmLogVo.getAlarmTime() == null){
            fb.setCode(0);
            fb.setMessage("报警时间不能为空");
            return gson.toJson(fb);
        }
        //获取报警的线路信息
        int i= alarmLogServcie.addAlarmLog(addAlarmLogVo);
        if(i == 0){
            fb.setCode(0);
            fb.setMessage("添加成功");
        }else{
            fb.setCode(0);
            fb.setMessage("添加失败");
        }
        return gson.toJson(fb);
    }
}
